Codeforces Round #295 (Div. 2)——B——Two Buttons

Vasya has found a strange device. On the front panel of a device there are: a red button, a blue button and a display showing some positive integer. After clicking the red button, device multiplies the displayed number by two. After clicking the blue button, device subtracts one from the number on the display. If at some point the number stops being positive, the device breaks down. The display can show arbitrarily large numbers. Initially, the display shows number n.

Bob wants to get number m on the display. What minimum number of clicks he has to make in order to achieve this result?

Input

The first and the only line of the input contains two distinct integers n and m (1 ≤ n, m ≤ 104), separated by a space .

Output

Print a single number — the minimum number of times one needs to push the button required to get the number m out of number n.

Sample test(s)

input

4 6

output

2

input

10 1

output

9

Note

In the first example you need to push the blue button once, and then push the red button once.

In the second example, doubling the number is unnecessary, so we need to push the blue button nine times.

大意:n只能放大一倍或者减少一转化成m缩小一倍或者加上一,母牛的简化版~可以用DFS做

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int main()
{
    int n,m;
    while(~scanf("%d%d",&n,&m)){
        int step = 0;
        while(n <m){
            if(m%2 == 0){
            m/= 2;
            step++;
            }
           else {
                m++;
                step++;
           }
        }
        printf("%d\n",n - m + step);
    }
    return 0;
}

时间: 2024-11-11 01:04:58

Codeforces Round #295 (Div. 2)——B——Two Buttons的相关文章

【记忆化搜索】Codeforces Round #295 (Div. 2) B - Two Buttons

题意:给你一个数字n,有两种操作:减1或乘2,问最多经过几次操作能变成m: 随后发篇随笔普及下memset函数的初始化问题.自己也是涨了好多姿势. 代码 1 #include<iostream> 2 #include<cstdio> 3 #include<cstring> 4 #include<cstdlib> 5 #define INF 0x7fffffff; 6 using namespace std; 7 int DP[20100], vis[2010

Codeforces Round #295 (Div. 2)

A. Pangram 题意:给出长度为n的字符串,判断26个字母(比如a,A都算作a出现了)是否都在该串中出现了 1 #include<iostream> 2 #include<cstdio> 3 #include<cstring> 4 #include <cmath> 5 #include<algorithm> 6 using namespace std; 7 8 typedef long long LL; 9 10 11 12 int mai

Codeforces Round #295 (Div. 1) C. Pluses everywhere (组合数学+乘法逆元)

这题可以这样想: 对于当前第i位来说,该位若在个位上出现,那么第i位和第i+1位中间肯定有一个"+",剩下的k-1个"+"分布在剩下的n-2个空隙中,所以出现的总次数是C(n-2,k).同理,在十位上出现的总次数是C(n-3,k).于是每个数字的贡献值就可以求出来了,累加即可. 所以大体思路是遍历所有可能出现的位数,从个位开始,分成两部分计算,一部分用前缀和计算出前面所有的在该位上的贡献和,另一部分算出当前位置在该位上的贡献值. 然后对于求组合数,可以先将阶乘预处理

Codeforces Round #295 (Div. 2) A+B+C

A题:找出字符串中是否出现了26个英文字母,不区分大小写 #include <cstdio> #include <cstring> #include <algorithm> using namespace std ; char str[200] ; int a[30] , b[30] ; int main() { int n , i ; scanf("%d", &n) ; scanf("%s", str) ; memset

C. DNA Alignment 数学公式推导 Codeforces Round #295 (Div. 2)

C. DNA Alignment time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Vasya became interested in bioinformatics. He's going to write an article about similar cyclic DNA sequences, so he invente

Codeforces Round #295 (Div. 1) B. Cubes (STL+类拓扑)

最近课业繁重,这题写了两天..昨晚睡觉的时候才突然想到了最后一点的解决方法. 不知道该不该叫做拓扑..感觉还是挺像的..就把标题称之为类拓扑了..这题的方法是用map来标记状态是否存在,然后用类似拓扑的方法不断的找拿走后依然稳定的方块,我用了两个优先队列来维护,分别取最大和最小.然后就是模拟这个过程取方块了. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queu

Codeforces Round #295 (Div. 1)

A 简单题 B 有m个方块 每个方块有一个值 并且是堆起来稳定的 一个方块可以拿掉当且仅当剩下的还是稳定的 双方轮流拿 从左到右放组成一个m进制的数 #include <cstdio> #include <cstring> #include <queue> #include <set> #include <map> #include <algorithm> using namespace std; const __int64 mod

Codeforces Round #295 (Div. 2)——A——Pangram

A word or a sentence in some language is called a pangram if all the characters of the alphabet of this language appear in it at least once. Pangrams are often used to demonstrate fonts in printing or test the output devices. You are given a string c

codeforces 521a//DNA Alignment// Codeforces Round #295(Div. 1)

题意:如题定义的函数,取最大值的数量有多少? 结论只猜对了一半. 首先,如果只有一个元素结果肯定是1.否则.s串中元素数量分别记为a,t,c,g.设另一个串t中数量为a',t',c',g'.那么,固定s串,移动t串时,增加的量为p=a*a'+t*t'+c*c'+g*g'.注意a'+t'+c'+g'是等于串长,那么减少a,t,c,g中最少的对应的那个a',t',c',g',增加到最大的那个上,p值是上升的.而且如果a==t那么a'和t'的数量互换是不影响p值的.因此结论是这种情况下,t串可随意 放